/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   interface.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_INTERFACE_H
#define UHDM_INTERFACE_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class interface : public instance {
  public:
    // Implicit constructor used to initialize all members,
    // comment: interface();
    ~interface() final {}
    
    const BaseClass* VpiParent() const final { return vpiParent_; }

    bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    unsigned int UhdmParentType() const final { return uhdmParentType_; }

    bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    const std::string& VpiFile() const final;

    bool VpiFile(const std::string& data) final;

    unsigned int VpiLineNo() const final { return vpiLineNo_; }

    bool VpiLineNo(unsigned int data) final { vpiLineNo_ = data; return true;}

    unsigned int VpiIndex() const { return vpiIndex_; }

    bool VpiIndex(unsigned int data) { vpiIndex_ = data; return true;}

    unsigned int VpiType() { return vpiInterface; }

    const instance_array* Instance_array() const { return instance_array_; }

    bool Instance_array(instance_array* data) { instance_array_ = data; return true;}

    VectorOfprocess* Process() const { return process_; }

    bool Process(VectorOfprocess* data) { process_ = data; return true;}

    VectorOfinterface_tf_decl* Interface_tf_decls() const { return interface_tf_decls_; }

    bool Interface_tf_decls(VectorOfinterface_tf_decl* data) { interface_tf_decls_ = data; return true;}

    VectorOfmodport* Modports() const { return modports_; }

    bool Modports(VectorOfmodport* data) { modports_ = data; return true;}

    const clocking_block* Global_clocking() const { return global_clocking_; }

    bool Global_clocking(clocking_block* data) { global_clocking_ = data; return true;}

    const clocking_block* Default_clocking() const { return default_clocking_; }

    bool Default_clocking(clocking_block* data) { default_clocking_ = data; return true;}

    VectorOfmod_path* Mod_paths() const { return mod_paths_; }

    bool Mod_paths(VectorOfmod_path* data) { mod_paths_ = data; return true;}

    VectorOfcont_assign* Cont_assigns() const { return cont_assigns_; }

    bool Cont_assigns(VectorOfcont_assign* data) { cont_assigns_ = data; return true;}

    VectorOfinterface* Interfaces() const { return interfaces_; }

    bool Interfaces(VectorOfinterface* data) { interfaces_ = data; return true;}

    VectorOfinterface_array* Interface_arrays() const { return interface_arrays_; }

    bool Interface_arrays(VectorOfinterface_array* data) { interface_arrays_ = data; return true;}

    VectorOfport* Ports() const { return ports_; }

    bool Ports(VectorOfport* data) { ports_ = data; return true;}

    const any* Expr_dist() const { return expr_dist_; }

    bool Expr_dist(any* data) {if (!expr_distGroupCompliant(data)) return false; expr_dist_ = data; return true;}

    UHDM_OBJECT_TYPE UhdmType() const final { return uhdminterface; }   
  private:
    
    BaseClass* vpiParent_;

    unsigned int uhdmParentType_;

    SymbolFactory::ID vpiFile_;

    unsigned int vpiLineNo_;

    unsigned int vpiIndex_;

    instance_array* instance_array_;

    VectorOfprocess* process_;

    VectorOfinterface_tf_decl* interface_tf_decls_;

    VectorOfmodport* modports_;

    clocking_block* global_clocking_;

    clocking_block* default_clocking_;

    VectorOfmod_path* mod_paths_;

    VectorOfcont_assign* cont_assigns_;

    VectorOfinterface* interfaces_;

    VectorOfinterface_array* interface_arrays_;

    VectorOfport* ports_;

    any* expr_dist_;

  };

  
  class interfaceFactory {
  friend Serializer;
  public:
  interface* Make() {
    interface* obj = new interface();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<interface*> objects_;
  };
  
  
  class VectorOfinterfaceFactory {
  friend Serializer;
  public:
  std::vector<interface*>* Make() {
    std::vector<interface*>* obj = new std::vector<interface*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<interface*>*> objects_;
  };

};

#endif

