/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   parameter.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_PARAMETER_H
#define UHDM_PARAMETER_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class parameter : public parameters {
  public:
    // Implicit constructor used to initialize all members,
    // comment: parameter();
    ~parameter() final {}
    
    const BaseClass* VpiParent() const final { return vpiParent_; }

    bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    unsigned int UhdmParentType() const final { return uhdmParentType_; }

    bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    const std::string& VpiFile() const final;

    bool VpiFile(const std::string& data) final;

    unsigned int VpiLineNo() const final { return vpiLineNo_; }

    bool VpiLineNo(unsigned int data) final { vpiLineNo_ = data; return true;}

    int VpiConstType() const { return vpiConstType_; }

    bool VpiConstType(int data) { vpiConstType_ = data; return true;}

    bool VpiSigned() const { return vpiSigned_; }

    bool VpiSigned(bool data) { vpiSigned_ = data; return true;}

    const std::string& VpiValue() const;

    bool VpiValue(const std::string& data);

    const typespec* Typespec() const { return typespec_; }

    bool Typespec(typespec* data) { typespec_ = data; return true;}

    const expr* Expr() const { return expr_; }

    bool Expr(expr* data) { expr_ = data; return true;}

    const expr* Left_expr() const { return left_expr_; }

    bool Left_expr(expr* data) { left_expr_ = data; return true;}

    const expr* Right_expr() const { return right_expr_; }

    bool Right_expr(expr* data) { right_expr_ = data; return true;}

    unsigned int VpiType() { return vpiParameter; }

    UHDM_OBJECT_TYPE UhdmType() const final { return uhdmparameter; }   
  private:
    
    BaseClass* vpiParent_;

    unsigned int uhdmParentType_;

    SymbolFactory::ID vpiFile_;

    unsigned int vpiLineNo_;

    int vpiConstType_;

    bool vpiSigned_;

    SymbolFactory::ID vpiValue_;

    typespec* typespec_;

    expr* expr_;

    expr* left_expr_;

    expr* right_expr_;

  };

  
  class parameterFactory {
  friend Serializer;
  public:
  parameter* Make() {
    parameter* obj = new parameter();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<parameter*> objects_;
  };
  
  
  class VectorOfparameterFactory {
  friend Serializer;
  public:
  std::vector<parameter*>* Make() {
    std::vector<parameter*>* obj = new std::vector<parameter*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<parameter*>*> objects_;
  };

};

#endif

